glibmm: Gio::UnixFDList Class Reference

glibmm 2.31.0.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions
Gio::UnixFDList Class Reference
Portable Network I/O Functionality

UnixFDList - An object containing a set of UNIX file descriptors. More...

`#include <giomm/unixfdlist.h>`

Inheritance diagram for Gio::UnixFDList:
[legend]

List of all members.

## Public Member Functions
virtual | ~UnixFDList ()
GUnixFDList* | gobj ()
| Provides access to the underlying C GObject.
const GUnixFDList* | gobj () const
| Provides access to the underlying C GObject.
GUnixFDList* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
int | get_length () const
| Gets the length of list (ie: the number of file descriptors contained within).
int | get (int index) const
| Gets a file descriptor out of list.
const Glib::ArrayHandle< int > | peek_fds () const
| Returns the array of file descriptors that is contained in this object.
Glib::ArrayHandle< int > | steal_fds ()
| Returns the array of file descriptors that is contained in this object.
int | append (int fd)
| Adds a file descriptor to list.
## Static Public Member Functions
static Glib::RefPtr< UnixFDList > | create ()
| Creates a new UnixFDList containing no file descriptors.
static Glib::RefPtr< UnixFDList > | create (const Glib::ArrayHandle< int >& fds)
| Creates a new UnixFDList containing the file descriptors given in fds.
static Glib::RefPtr< UnixFDList > | create (const Glib::ArrayHandle< int >& fds, int n_fds)
| Creates a new UnixFDList containing the file descriptors given in fds.
## Protected Member Functions
| UnixFDList ()
| UnixFDList (const Glib::ArrayHandle< int >& fds)
| UnixFDList (const Glib::ArrayHandle< int >& fds, int n_fds)
## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::UnixFDList > | wrap (GUnixFDList* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

UnixFDList - An object containing a set of UNIX file descriptors.

A UnixFDList contains a list of file descriptors. It owns the file descriptors that it contains, closing them when finalized.

It may be wrapped in a UnixFDMessage and sent over a Socket in the G_SOCKET_ADDRESS_UNIX family by using Gio::Socket::send() and received using Gio::Socket::receive().

Since glibmm 2.28:

## Constructor & Destructor Documentation

virtual Gio::UnixFDList::~UnixFDList | ( |  | ) | `[virtual]`

Gio::UnixFDList::UnixFDList | ( |  | ) | `[protected]`

Gio::UnixFDList::UnixFDList | ( | const Glib::ArrayHandle< int >& | fds | ) | `[explicit, protected]`

Gio::UnixFDList::UnixFDList | ( | const Glib::ArrayHandle< int >& | fds,
|  | int | n_fds
| ) |  | `[explicit, protected]`

## Member Function Documentation

int Gio::UnixFDList::append | ( | int | fd | ) |

Adds a file descriptor to list.

The file descriptor is duplicated using dup(). You keep your copy of the descriptor and the copy contained in list will be closed when list is finalized.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

The index of the file descriptor in the list is returned. If you use this index with g_unix_fd_list_get() then you will receive back a duplicated copy of the same file descriptor.

Since glibmm 2.24:

Parameters:

  fd | A valid open file descriptor.

Returns:
  The index of the appended fd in case of success, else -1 (and error is set).

Exceptions:

  Glib::Error. |

static Glib::RefPtr<UnixFDList> Gio::UnixFDList::create | ( |  | ) | `[static]`

Creates a new UnixFDList containing no file descriptors.

Since glibmm 2.24:

Returns:
  A new UnixFDList.

static Glib::RefPtr<UnixFDList> Gio::UnixFDList::create | ( | const Glib::ArrayHandle< int >& | fds | ) | `[static]`

Creates a new UnixFDList containing the file descriptors given in fds.

The file descriptors become the property of the new list and may no longer be used by the caller. The array itself is owned by the caller.

Each file descriptor in the array should be set to close-on-exec.

Parameters:

  fds | The list of file descriptors to use for creation.

Returns:
  A new UnixFDList.

static Glib::RefPtr<UnixFDList> Gio::UnixFDList::create | ( | const Glib::ArrayHandle< int >& | fds,
|  | int | n_fds
| ) |  | `[static]`

Creates a new UnixFDList containing the file descriptors given in fds.

The file descriptors become the property of the new list and may no longer be used by the caller. The array itself is owned by the caller.

Each file descriptor in the array should be set to close-on-exec.

If n_fds is -1 then fds must be terminated with -1.

Since glibmm 2.24:

Parameters:

  fds | The initial list of file descriptors.
  n_fds | The length of #fds, or -1.

Returns:
  A new UnixFDList.

int Gio::UnixFDList::get | ( | int | index | ) | const

Gets a file descriptor out of list.

index specifies the index of the file descriptor to get. It is a programmer error for index to be out of range; see g_unix_fd_list_get_length().

The file descriptor is duplicated using dup() and set as close-on-exec before being returned. You must call close() on it when you are done.

A possible cause of failure is exceeding the per-process or system-wide file descriptor limit.

Since glibmm 2.24:

Parameters:

  index | The index into the list.

Returns:
  The file descriptor, or -1 in case of error.

int Gio::UnixFDList::get_length | ( |  | ) | const

Gets the length of list (ie: the number of file descriptors contained within).

Since glibmm 2.24:

Returns:
  The length of list.

const GUnixFDList* Gio::UnixFDList::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GUnixFDList* Gio::UnixFDList::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::ObjectBase.

GUnixFDList* Gio::UnixFDList::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

const Glib::ArrayHandle<int> Gio::UnixFDList::peek_fds | ( |  | ) | const

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors remain the property of the list. The caller must not close them. The array is valid only until list is changed in any way.

Returns:
  The list of file descriptors.

Since glibmm 2.28:

Glib::ArrayHandle<int> Gio::UnixFDList::steal_fds | ( |  | ) |

Returns the array of file descriptors that is contained in this object.

After this call, the descriptors are no longer contained in the list. Further calls will return an empty list (unless more descriptors have been added).

The caller is responsible for closing all of the file descriptors. The file descriptors in the array are set to close-on-exec.

Returns:
  The list of file descriptors.

Since glibmm 2.28:

## Friends And Related Function Documentation

Glib::RefPtr< Gio::UnixFDList > wrap | ( | GUnixFDList * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.